////////////////////////////////////////////////////////////////////////
// cube3.c
// Affichage d'un cube 3d en fil de fer
// VERSION :
//  - Avec double buggering
//  - utilisation de PutPixelFastMode1
////////////////////////////////////////////////////////////////////////
#include "conio2.h"
#include <stdio.h>
#include <math.h>

#define KM_WAIT_CHAR_s \
	__asm \
	call #0xBB06 \
	__endasm

#define  SCR_SET_MODE1_s \
	__asm	ld a,#1 \
	call #0xBC0E \
	__endasm;

typedef struct
{
  long x,y,z;
} point3D;

typedef struct
{
  int x,y;
} point2D;


point3D Sommet[8];   // les sommets du cube
point3D Point3D[8];  // les sommets apres rotation
point2D Point2D[8];  // les sommets apres projection

int Nb_points;

int Xoff;
int Yoff;
int Zoff;

/* Tableaux precalcules de sinus et cosinus */
float *Sin;
float *Cos;

float matrice[3][3];       /* Matrice de rotation 3*3 */

int xa,ya,za;

unsigned int CurentSCR = 0xc000;	// cran affich
unsigned int DrawSCR = 0x4000;		// cran ou l'on dessine
unsigned char OHCurSCR = 0x60;  // pour la fonction PutPixelFastMode1 c'est l'octet haut de l'adresse de l'cran / 2


unsigned char glob_color = 0;

void SetPenM1( unsigned char color )
{
	switch ( color % 4 )
	{
		case 0:
			glob_color = 0;
			break;
		case 1:
			glob_color = 240;  // 0xF0
			break;
		case 2:
			glob_color = 15;  // 0x0F
			break;
		case 3:
			glob_color = 255;  // 0xFF
			break;
	}
}

void PutPixelFastMode1(unsigned int nX, unsigned char nY)
{
// Input: DE = X (0..319), HL = Y (0..199) 

__asm

	; on rcupre les paramtres
	LD E, 4(IX)
	LD D, 5(IX)

	LD L, 6(IX)
	LD H,#0			; juste pour tre sur.

FPLOT:
	LD A, L			;A = octet bas de Y
	AND #0x7		;isole les Bit 0..2  (00000111)
	LD H, A			;= y MOD 8 vers H
	XOR L			;A = Bit 3..7 of Y
	LD L, A			;= (Y\8)*8 vers L
	LD C, A			;stock dans C
	;LD B, #0x60		;B = &C0\2 = octet haut adresse de depart de l ecran \ 2
	;LD B, (#_OHCurSCR)
	ld	iy,#_OHCurSCR
	ld	B,0 (iy)
	
					; REMARQUE
					; si vous voulez dessiner dans un autre ecran que celui d origine en C000 (par exemple 4000)
					; il faut changer cette valeur.
		
	ADD HL, HL		;HL * 2
	ADD HL, HL		;HL * 4
	ADD HL, BC		;+ BC = adresse de depart
	ADD HL, HL		;de la ligne de pixels
		
	LD A, E			;octet bas de X dans A
	SRL D			;calcule X\4, Car 
	RR E			;4 pixels par bit
	SRL E
	ADD HL, DE		;+ HL = adresse du pixel  modifier
		
	LD C, #0x88		;masque de bits pour le mode 1 (10001000)
	AND #3			;A = X MOD 4 (00000011)
	JR Z, NSHIFT	;-> = 0, aucun deplacement
SHIFT:
 	SRL C			;dplacer masque de pixel
	DEC A			;compteur de boucle
	JR NZ,SHIFT		;-position
		
NSHIFT:
	LD A,(#_glob_color); recupere le masque de couleur
					; REMARQUE
					; La couleur peut etre recupere en memoire a l adresse B6A3 pour les 664 et 6128 et B338 pour le 464
					; moi j ai prfr passer par un variable globale.
	XOR (HL)		;XOR octet du pixel
	AND C			;AND masque de pixel
	XOR (HL)		;XOR octet du pixel
	LD (HL), A		;nouveau octet du pixel
	
__endasm;
}

void lineBresenham(int x1,int y1,int x2,int y2, unsigned char nColor)
{
    int cx, cy,
        ix, iy,
        dx, dy, 
        ddx= x2-x1, ddy= y2-y1;
		
	SetPenM1( nColor );
     
    if (!ddx) { //vertical line special case
        if (ddy > 0) {
            cy= y1;  
            do PutPixelFastMode1(x1, cy++);
            while (cy <= y2);
            return;
        } else {
            cy= y2;
            do PutPixelFastMode1(x1, cy++);
            while (cy <= y1);
            return;
        }
    }
    if (!ddy) { //horizontal line special case
        if (ddx > 0) {
            cx= x1;
            do PutPixelFastMode1(cx, y1);
            while (++cx <= x2);
            return;
        } else {
            cx= x2; 
            do PutPixelFastMode1(cx, y1);
            while (++cx <= x1);
            return;
        }
    }
    if (ddy < 0) { iy= -1; ddy= -ddy; }//pointing up
            else iy= 1;
    if (ddx < 0) { ix= -1; ddx= -ddx; }//pointing left
            else ix= 1;
    dx= dy= ddx*ddy;
    cy= y1, cx= x1; 
    if (ddx < ddy) { // < 45 degrees, a tall line    
        do {
            dx-=ddy;
            do {
                PutPixelFastMode1(cx, cy);
                cy+=iy, dy-=ddx;
            } while (dy >=dx);
            cx+=ix;
        } while (dx > 0);
    } else { // >= 45 degrees, a wide line
        do {
            dy-=ddx;
            do {
                PutPixelFastMode1(cx, cy);
                cx+=ix, dx-=ddy;
            } while (dx >=dy);
            cy+=iy;
        } while (dy > 0);
    }
}

// swap entre le scr C000 et 4000 (si l'ecrans n'est pas en 4000 on repasse en C000)
// Sans utilisation de fonction systeme
// On attaque directement le CRTC
void SwapScr()
{
	if ( CurentSCR == 0xC000 )
	{
		// on passe l'ecran en 4000
		//Ecran en &4000 : OUT &BC00,12:0UT &BD00,&X 00010000
		__asm
			ld  bc,#0xBC0C
			out (c),c
			ld  bc,#0xBD00+16 ;write a value
			out (c),c
		__endasm;
		CurentSCR = 0x4000;
		DrawSCR = 0xC000;
		OHCurSCR = 0x60;  //(0xC0 / 2 )
	}
	else
	{
		// on passe l'ecran en C000
		// Ecran en &C000 : OUT &BC00,12:0UT &BD00,&X 00110000 (standard du systme)
		__asm
			ld  bc,#0xBC0C
			out (c),c
			ld  bc,#0xBD00+48 ;write a value
			out (c),c
		__endasm;
	
		CurentSCR = 0xC000;
		DrawSCR = 0x4000;
		OHCurSCR = 0x20;  //(0x40 / 2 )
	}
}

// IL FAUT UTILISER "--oldralloc" POUR COMPILER !
// code retout :
// 0 Ok
// -1 Erreur
int ReadFileBin(char* filename, char* readbuffer)
{

__asm

	; Initialisation de l amsdos (ROM 7) avant le changement d un fichier
	ld   	hl,(#0xBE7D)	; adresse de la zone rserve AMSDOS
	ld   	a,(hl)			; drive
	push 	hl
	push 	af
	ld      de,#0x40		;DE-HL contient la plage dans laquelle la rom doit tre recherche
	ld      hl,#0xABFF
	ld      c,#7			;contient l adresse de slection de rom  tester
	call    #0xBCCE			;initialisation d une rom de second plan
	pop		af
	pop		hl
	ld		(hl),a			; on remet le drive courant
	
	; rcupere le parametre char* filename
	LD L, 4(IX)
	LD H, 5(IX)
	;LD B, 8(IX)
	
	; calcule la longeur du nom de fichier
	call getfilenamesize
	
	; B = longueur du nom de fichier en caractres
	; HL = l adresse de dbut du nom de fichier
	
	;; DE = l adresse d un tampon 2k
	;; En mode disque: cette mmoire tampon n est pas utilis lorsque Fonction firmware 
	;; CAS EN DIRECT est utilis, il est donc prudent de le mettre nulle (0)
	;; Vous le souhaitez.
	ld de,#0

	;; fonction du firmware pour ouvrir un fichier en lecture
	call #0xbc77

	;; cas_in_open retour:
	;; si le fichier a t ouvert avec succs:
	;; - carry est vrais
	;; - HL contient l adresse de l en-tte du fichier s AMSDOS
	;; - DE contient l adresse de chargement du fichier ( partir de l en-tte)
	;; - BC contient la longueur du fichier ( partir de l en-tete du fichier)
	;; - A contient le type de fichier (2 pour les fichiers binaires)
	; si une erreur on sort le la fonction
    JR NC,ERRDRIV
    JR Z,ERRDRIV
	
	;; fonction du firmware pour charger le fichier en entier
	;; cela fonctionne avec les fichiers qui ont un en-tte AMSDOS (les
	;; fichiers ASCII n ont pas un en-tte)
	
	; rcupere le parametres char* readbuffer
	LD L, 6(IX)
	LD H, 7(IX)

	;; Lecture du fichier
	call #0xbc83

	;; fonction du firmware pour fermer un fichier ouvert en lecture
	call #0xbc7a
	
	jp asmFin

ERRDRIV:
	;LD (FLGERR),A  ;Sort ici si erreur drive
	CALL #0xBC7D
	; il y a une erreur, on retourne cette erreur....
	; enfin pour le moment juste la valeur -1
	ld	hl,#0xFFFF
	pop	ix
	ret
	
	
getfilenamesize:
	push de
	push hl
	ld e,#0
getfilenamesizeloop:
	ld a, (hl)
	or a
	jp z, getfilenamesizeend
	inc hl
	inc e
	jp getfilenamesizeloop
getfilenamesizeend:
	pop hl
	ld b, e
	pop de
	ret	
	
asmFin: 
 	
 __endasm;

 return 0;
}

void Rotation(int Xa, int Ya, int Za)
{
  int i;

  // Calcul de la matrice de rotation 3*3
  matrice[0][0] = Cos[Za]*Cos[Ya];
  matrice[1][0] = Sin[Za]*Cos[Ya];
  matrice[2][0] = -Sin[Ya];

  matrice[0][1] = Cos[Za]*Sin[Ya]*Sin[Xa] - Sin[Za]*Cos[Xa];
  matrice[1][1] = Sin[Za]*Sin[Ya]*Sin[Xa] + Cos[Xa]*Cos[Za];
  matrice[2][1] = Sin[Xa]*Cos[Ya];

  matrice[0][2] = Cos[Za]*Sin[Ya]*Cos[Xa] + Sin[Za]*Sin[Xa];
  matrice[1][2] = Sin[Za]*Sin[Ya]*Cos[Xa] - Cos[Za]*Sin[Xa];
  matrice[2][2] = Cos[Xa]*Cos[Ya];


  // Rotation des sommets de l'objet
  for(i=0;i<Nb_points;i++)
  {
    Point3D[i].x =   matrice[0][0]*Sommet[i].x
				   + matrice[1][0]*Sommet[i].y
				   + matrice[2][0]*Sommet[i].z;

    Point3D[i].y =   matrice[0][1]*Sommet[i].x
				   + matrice[1][1]*Sommet[i].y
				   + matrice[2][1]*Sommet[i].z;

    Point3D[i].z =   matrice[0][2]*Sommet[i].x
				   + matrice[1][2]*Sommet[i].y
				   + matrice[2][2]*Sommet[i].z;
  }
}

void Projection(void)
{
  int i;

  for(i=0;i<Nb_points;i++)
  {
    Point2D[i].x=(Point3D[i].x<<8)/(Point3D[i].z+Zoff)+Xoff;
    Point2D[i].y=(Point3D[i].y<<8)/(Point3D[i].z+Zoff)+Yoff;
  }
}

void Initialiser(void)
{
  Sommet[0].x = -100;  Sommet[0].y = -100;  Sommet[0].z = -100;
  Sommet[1].x =  100;  Sommet[1].y = -100;  Sommet[1].z = -100;
  Sommet[2].x =  100;  Sommet[2].y =  100;  Sommet[2].z = -100;
  Sommet[3].x = -100;  Sommet[3].y =  100;  Sommet[3].z = -100;
  Sommet[4].x =  100;  Sommet[4].y = -100;  Sommet[4].z =  100;
  Sommet[5].x = -100;  Sommet[5].y = -100;  Sommet[5].z =  100;
  Sommet[6].x = -100;  Sommet[6].y =  100;  Sommet[6].z =  100;
  Sommet[7].x =  100;  Sommet[7].y =  100;  Sommet[7].z =  100;
}

void ligne(int a, int b, unsigned char couleur)
{
  lineBresenham(Point2D[a].x,Point2D[a].y,Point2D[b].x,Point2D[b].y, couleur);
}


void FilDeFer(unsigned char couleur)
{
 // On affiche la face avant
 ligne(0,1,1); ligne(1,2,1);
 ligne(2,3,1); ligne(3,0,1);

 // Puis la face arriere
 ligne(4,5,2); ligne(5,6,2);
 ligne(6,7,2); ligne(7,4,2);

 // Et enfin les aretes restantes
 ligne(0,5,3);
 ligne(1,4,3);
 ligne(2,7,3);
 ligne(3,6,3);
}

// Efface l'ecran en utilisent la pile
// dtournmne de la pile pour faire un cls super rapide !
int PILE;
unsigned int adrPile;
void CLS_WidthPile()
{
__asm
       DI
       LD           (#_PILE),SP
__endasm;

if ( DrawSCR == 0xC000 )
{
__asm
		LD           SP,#0
__endasm;
}
else
{
__asm
		LD           SP,#0x8000
__endasm;
}
	   
__asm
       LD           B,#0
       LD           DE,#0
BOUC2:   PUSH         DE
       PUSH         DE
       PUSH         DE
       PUSH         DE
       PUSH         DE
       PUSH         DE
       PUSH         DE
       PUSH         DE
       PUSH         DE
       PUSH         DE
       PUSH         DE
       PUSH         DE
       PUSH         DE
       PUSH         DE
       PUSH         DE
       PUSH         DE
       PUSH         DE
       PUSH         DE
       PUSH         DE
       PUSH         DE
       PUSH         DE
       PUSH         DE
       PUSH         DE
       PUSH         DE
       PUSH         DE
       PUSH         DE
       PUSH         DE
       PUSH         DE
       PUSH         DE
       PUSH         DE
       PUSH         DE
       PUSH         DE
       DJNZ         BOUC2
       LD           SP,(#_PILE)
	   EI
       RET
	   
__endasm;
}


void Afficher(unsigned char couleur)
{
	CLS_WidthPile();
	
	// On dessine 
	// en fil de fer
	FilDeFer(couleur);
	
	// on swap l'ecan....
	SwapScr();
}

void Load_Sinus(void)
{
	ReadFileBin("sincos.dat", 0x8000);
}


unsigned char char3,char4;
// donne le temps coule en 1/300' de seconde depuis l'allumage du CPC
// ou BD10: positionne le compteur interne  une valeur prcise
unsigned int GetTime_s()
{
	unsigned int nTime = 0;

	__asm
	CALL #0xBD0D ;KL TIME PLEASE
	PUSH HL
	POP DE
	LD HL, #_char3
	LD (HL), D
	LD HL, #_char4
	LD (HL), E
	__endasm;

	nTime = (char3 << 8) + char4;

	return nTime;
}


void main()
{
	unsigned int nTimeStart = 0;
	unsigned int nTime1 = 0;
	unsigned int nTime2 = 0;

	// initalisation de l'adresse de l'ecran
	CurentSCR = 0xC000;
	DrawSCR = 0x4000;
	OHCurSCR = 0x20;  //(0x40 / 2 )
	
	// initalisation des pointeur pour les sin et cos
	Sin = (float *)((unsigned int)0x8000);
	Cos = (float *)((unsigned int)0x8000+1440);
	
	Nb_points = 8;

	Xoff = 160;
	Yoff = 100;
	Zoff = 600; 
  
	//SCR_SET_MODE 1
	__asm
		ld a,#1
		call #0xBC0E
	__endasm;

	// chargement des table Sin et Cos...
	Load_Sinus();

	// initialise les valeurs de lobjet 3D (le cube)
	Initialiser();
	xa=ya=za=0;

	// Animation de note cube jusqu'a pression d'une touche
	while( 1 )
	{
		Rotation(xa,ya,za);
		Projection();

		Afficher(1);

		xa=(xa+2)%360;
		ya=(ya+6)%360;
		za=(za+2)%360;

		if(kbhit())
			break;
	}
}
